Unit ADH1C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AFH1C_p;

procedure ADH1C(var A :Array of Complex; var D1 :Complex;
                var D2 :Integer; N :Integer; var IERR :Integer);

implementation

procedure ADH1C(var A :Array of Complex; var D1 :Complex;
                var D2 :Integer; N :Integer; var IERR :Integer);
var
K,I :Integer;
label
_1,_2,_3,_4,_6,_5;
begin
AFH1C(A,N,IERR);
if ( IERR = 65 ) 
 then goto _5;
_1:
K := 0;
D1 := Cmplx(1.0,0.E0);
D2 := 0;
for I:=1 to N do
 begin
  K := K+I;
  D1 := MulC(D1,A[K-1]);
_2:
  if ( Cabs(D1) < 1.0 ) 
   then goto _3;
  D1 := MulC(D1,Cmplx(0.0625,0.E0));
  D2 := D2+4;
  goto _2;
_3:
  if ( Cabs(D1) >= 0.0625 ) 
   then goto _4;
  D1 := MulC(D1,Cmplx(16.0,0.E0));
  D2 := D2-4;
  goto _3;
_4:
 end;
D1 := MulC(D1,D1);
D2 := D2+D2;
_6:
if ( Cabs(D1) >= 0.0625 ) 
 then goto _5;
D1 := MulC(D1,Cmplx(16.0,0.E0));
D2 := D2-4;
goto _6;
_5:
end;

end.
