Unit AFH1C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAF10_p;

procedure AFH1C(var A :Array of Complex; N :Integer;
                var IERR :Integer);

implementation

procedure AFH1C(var A :Array of Complex; N :Integer;
                var IERR :Integer);
var
I,J,K,I1,II,K1,L1,L2,I2,M :Integer;
S,R :Real;
C :Complex;
label
_1,_2,_3,_4,_5,_6;
begin
if ( Creal(A[0]) <= 0.0 )
 then goto _5;
S := Cabs(A[0]);
S := Sqrt(S);
K := 2;
for J:=2 to N do
 begin
  A[K-1] := DivC(A[K-1],Cmplx(S,0.0));
  K := K+J;
_1:
 end;
A[0] := Cmplx(S,0.0);
for I:=2 to N do
 begin
  R := 0.0;
  L1 := I*(I-1) div 2+1;
  L2 := L1+I-2;
  for J:=L1 to L2 do
   begin
    R := R+(Cabs(A[J-1]))*(Cabs(A[J-1]));
_2:
   end;
  K := L2+1;
  C := SubC(A[K-1],Cmplx(R,0.0));
  R := Creal(C);
  if ( R <= 0.0 )
   then goto _5;
  S := Cabs(C);
  S := Sqrt(S);
  A[K-1] := Cmplx(S,0.0);
  if ( I = N ) 
   then goto _6;
  I1 := I-1;
  K := I*(I+1) div 2+I;
  I2 := I;
  II := I+1;
  for J:=II to N do
   begin
    K1 := K-I1;
    C := Cmplx(0.0,0.0);
    for M:=L1 to L2 do
     begin
      C := AddC(C,MulC(Conjg(A[M-1]),A[K1-1]));
      K1 := K1+1;
_3:
     end;
    I2 := I2+1;
    A[K-1] := DivC(SubC(A[K-1],C),Cmplx(S,0.0));
    K := K+I2;
_4:
   end;
 end;
IERR := 0;
goto _6;
_5:
IERR := 65;
UTAF10(IERR,11);
_6:
end;

end.
